*** xlog.c.orig	Tue Feb 15 14:00:12 2000
--- xlog.c	Mon Mar 06 12:59:40 2000
***************
*** 726,732 ****
--- 726,736 ----
  	unlink(path);
  
  tryAgain:
+ #ifndef __CYGWIN__
  	fd = open(path, O_RDWR|O_CREAT|O_EXCL, S_IRUSR|S_IWUSR);
+ #else
+ 	fd = open(path, O_RDWR|O_CREAT|O_EXCL|O_BINARY, S_IRUSR|S_IWUSR);
+ #endif
  	if (fd < 0 && (errno == EMFILE || errno == ENFILE))
  	{
  		fd = errno;
***************
*** 767,773 ****
--- 771,781 ----
  	XLogFileName(path, log, seg);
  
  tryAgain:
+ #ifndef __CYGWIN__
  	fd = open(path, O_RDWR);
+ #else
+ 	fd = open(path, O_RDWR | O_BINARY);
+ #endif
  	if (fd < 0 && (errno == EMFILE || errno == ENFILE))
  	{
  		fd = errno;
***************
*** 1083,1089 ****
--- 1091,1101 ----
  	int		fd;
  
  tryAgain:
+ #ifndef __CYGWIN__
  	fd = open(ControlFilePath, O_RDWR);
+ #else
+ 	fd = open(ControlFilePath, O_RDWR | O_BINARY);
+ #endif
  	if (fd < 0 && (errno == EMFILE || errno == ENFILE))
  	{
  		fd = errno;
***************
*** 1145,1151 ****
--- 1157,1167 ----
  	CheckPoint		checkPoint;
  	XLogRecord	   *record;
  
+ #ifndef __CYGWIN__
  	fd = open(ControlFilePath, O_RDWR|O_CREAT|O_EXCL, S_IRUSR|S_IWUSR);
+ #else
+ 	fd = open(ControlFilePath, O_RDWR|O_CREAT|O_EXCL|O_BINARY, S_IRUSR|S_IWUSR);
+ #endif
  	if (fd < 0)
  		elog(STOP, "BootStrapXLOG failed to create control file (%s): %d", 
  					ControlFilePath, errno);
***************
*** 1249,1255 ****
--- 1265,1275 ----
  	 * Open/read Control file
  	 */
  tryAgain:
+ #ifndef __CYGWIN__
  	fd = open(ControlFilePath, O_RDWR);
+ #else
+ 	fd = open(ControlFilePath, O_RDWR | O_BINARY);
+ #endif
  	if (fd < 0 && (errno == EMFILE || errno == ENFILE))
  	{
  		fd = errno;
